/*
 * mount Ή fBAw chdir
 * $Id: cdr.c,v 0.6 1994/06/27 16:56:55 kyoko Exp $
 * Copyright (C) 1994 fubuki
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <ctype.h>
#include  <jctype.h>
#include  <sys/dos.h>

#define	MEMORYDISK		0xf9	/* default chdir media ID */
#define	NUMBER			1		/* default chdir media number */

typedef struct {
	int		id;
	char	*symbol;
} MEDIA;

const static char *rcsid = "$Id: cdr.c,v 0.6 1994/06/27 16:56:55 kyoko Exp $";

MEDIA	mediaSymbol[] = {
	{ 0xf9, "ram" },
	{ 0xf9, "rd" },
	{ 0xf9, "memory" },
	{ 0xf9, "tmp" },
	{ 0xf7, "scsi" },
	{ 0xf7, "sd" },
	{ 0xf7, "hd" },
	{ 0xf6, "mo" },
	{ 0xfe, "fd" },
	{ 0x00, "" }
};

char *
bslash2slash(char *s)
{
	char	*t = s;

	while(*s) {
		if (iskanji(*s)) {
			s += 2;
			continue;
		}
		else if ('\\' == *s)
			*s = '/';
		s++;
	}
	return t;
}

int
ismediasymbol(char *s)
{
	MEDIA	*n = mediaSymbol;

	while(0 != n->id) {
		if (0 == strncmp(s, n->symbol, strlen(s)))
			return n->id;
		n++;
	}
	return 0;
}

/* 16i -> l */
int
axtoi(char *s)
{
	int		n = 0;

	while(*s) {
		if (isdigit(*s))
			n = (n << 4) + (*s - '0');
		else if ('a' <= *s && 'f' >= *s)
			n = (n << 4) + ((*s - 'a') + 10);
		else
			return 0;
		s++;
	}
	return n;
}

int
main(int argc, char **argv)
{
	char			buffer1[128] = " :";
	char			buffer2[128];
	int				a, i, d, n, c = NUMBER;
	struct	_dpbptr	dpb;
	unsigned char	media, cdmedia = MEMORYDISK;

	if (1 < argc) {
		if (isdigit(argv[1][0]))
			c = atoi(argv[1]);
		else {
			if (0 == (cdmedia = ismediasymbol(argv[1]))) {
				cdmedia = axtoi(argv[1]);
			}
		}
		if (2 < argc) {
			if (isdigit(argv[2][0]))
				c = atoi(argv[2]);
			else {
				if (0 == (cdmedia = ismediasymbol(argv[2]))) {
					cdmedia = axtoi(argv[2]);
				}
			}
		}
	}

	if (0 == cdmedia) {
#ifdef	STDOUT
		puts(argv[1]);
#else
		fputs("usage: cdr [media id] [number]\n", stderr);
#endif /* STDOUT */
		return 2;
	}

	for(i = 'A', n = 1; i <= 'Z'; i++) {
		buffer1[0] = i;
		d = (i - 'A') + 1;
		a = _dos_getassign(buffer1, buffer2);
		switch(a) {
		case	0x40:	/* hCu */
			_dos_getdpb(d, &dpb);
			media = dpb.id;
			break;
		case	0x60:	/* zfBNg */
			_dos_rassign(buffer1);
			_dos_getdpb(d, &dpb);
			media = dpb.id;
			_dos_makeassign(buffer1, buffer2, a);
			break;
		case	0x50:	/* zhCu */
		default:		/* ݂ȂhCu */
			media = 0;
		}
		if (cdmedia == media && c == n) {
#ifdef STDOUT
			if (0x60 == a)
				puts(bslash2slash(buffer2));
			else {
				buffer2[3] = '\0';
				puts(bslash2slash(buffer2));
			}
#else
			_dos_chgdrv(toupper(*buffer2) - 'A');
			if (0x60 == a)
				_dos_chdir(buffer2);
			else
				_dos_chdir("\\");
#endif /* STDOUT */
			return 0;
		}
		if (cdmedia == media) n++;
	}
#ifdef	STDOUT
	puts(argv[1]);
#endif /* STDOUT */
	return 1;
}
